RadioLib Universal wireless communication library for Arduino

Public Member Functions | List of all members
LR1110 Class Reference

Derived class for LR1110 modules. More...

`#include <LR1110.h>`

Inheritance diagram for LR1110:

## Public Member Functions
| LR1110 (Module *mod)
| Default constructor. More...
int16_t | begin (float freq=434.0, float bw=125.0, uint8_t sf=9, uint8_t cr=7, uint8_t syncWord=RADIOLIB_LR11X0_LORA_SYNC_WORD_PRIVATE, int8_t power=10, uint16_t preambleLength=8, float tcxoVoltage=1.6)
| Initialization method for LoRa modem. More...
int16_t | beginGFSK (float freq=434.0, float br=4.8, float freqDev=5.0, float rxBw=156.2, int8_t power=10, uint16_t preambleLength=16, float tcxoVoltage=1.6)
| Initialization method for FSK modem. More...
int16_t | setFrequency (float freq)
| Sets carrier frequency. Allowed values are in range from 150.0 to 960.0 MHz. Will also perform calibrations. More...
int16_t | setFrequency (float freq, bool calibrate, float band=4)
| Sets carrier frequency. Allowed values are in range from 150.0 to 960.0 MHz. More...
int16_t | setOutputPower (int8_t power)
| Sets output power. Allowed values are in range from -9 to 22 dBm (high-power PA) or -17 to 14 dBm (low-power PA). More...
int16_t | setOutputPower (int8_t power, bool forceHighPower)
| Sets output power. Allowed values are in range from -9 to 22 dBm (high-power PA) or -17 to 14 dBm (low-power PA). More...
Public Member Functions inherited from LR11x0
| LR11x0 (Module *mod)
| Default constructor. More...
int16_t | begin (float bw, uint8_t sf, uint8_t cr, uint8_t syncWord, uint16_t preambleLength, float tcxoVoltage)
| Initialization method for LoRa modem. More...
int16_t | beginGFSK (float br, float freqDev, float rxBw, uint16_t preambleLength, float tcxoVoltage)
| Initialization method for FSK modem. More...
int16_t | reset ()
| Reset method. Will reset the chip to the default state using RST pin. More...
int16_t | transmit (uint8_t *data, size_t len, uint8_t addr=0) override
| Blocking binary transmit method. Overloads for string-based transmissions are implemented in PhysicalLayer. More...
int16_t | receive (uint8_t *data, size_t len) override
| Blocking binary receive method. Overloads for string-based transmissions are implemented in PhysicalLayer. More...
int16_t | transmitDirect (uint32_t frf=0) override
| Starts direct mode transmission. More...
int16_t | receiveDirect () override
| Starts direct mode reception. Only implemented for PhysicalLayer compatibility, as SX126x series does not support direct mode reception. Will always return RADIOLIB_ERR_UNKNOWN. More...
int16_t | scanChannel () override
| Performs scan for LoRa transmission in the current channel. Detects both preamble and payload. More...
int16_t | scanChannel (uint8_t symbolNum, uint8_t detPeak, uint8_t detMin)
| Performs scan for LoRa transmission in the current channel. Detects both preamble and payload. More...
int16_t | standby () override
| Sets the module to standby mode (overload for PhysicalLayer compatibility, uses 13 MHz RC oscillator). More...
int16_t | standby (uint8_t mode, bool wakeup=true)
| Sets the module to standby mode. More...
int16_t | sleep (bool retainConfig=true, uint32_t sleepTime=0)
| Sets the module to sleep mode. To wake the device up, call standby(). More...
void | setDio1Action (void(*func)(void))
| Sets interrupt service routine to call when DIO1 activates. More...
void | clearDio1Action ()
| Clears interrupt service routine to call when DIO1 activates.
void | setPacketReceivedAction (void(*func)(void))
| Sets interrupt service routine to call when a packet is received. More...
void | clearPacketReceivedAction ()
| Clears interrupt service routine to call when a packet is received.
void | setPacketSentAction (void(*func)(void))
| Sets interrupt service routine to call when a packet is sent. More...
void | clearPacketSentAction ()
| Clears interrupt service routine to call when a packet is sent.
int16_t | startTransmit (uint8_t *data, size_t len, uint8_t addr=0) override
| Interrupt-driven binary transmit method. Overloads for string-based transmissions are implemented in PhysicalLayer. More...
int16_t | finishTransmit () override
| Clean up after transmission is done. More...
int16_t | startReceive ()
| Interrupt-driven receive method with default parameters. Implemented for compatibility with PhysicalLayer. More...
int16_t | startReceive (uint32_t timeout, uint32_t irqFlags=RADIOLIB_LR11X0_IRQ_RX_DONE, size_t len=0)
| Interrupt-driven receive method. DIO1 will be activated when full packet is received. More...
uint32_t | getIrqStatus ()
| Reads the current IRQ status. More...
int16_t | readData (uint8_t *data, size_t len) override
| Reads data received after calling startReceive method. When the packet length is not known in advance, getPacketLength method must be called BEFORE calling readData! More...
int16_t | startChannelScan () override
| Interrupt-driven channel activity detection method. DIO1 will be activated when LoRa preamble is detected, or upon timeout. Defaults to CAD parameter values recommended by AN1200.48. More...
int16_t | startChannelScan (uint8_t symbolNum, uint8_t detPeak, uint8_t detMin)
| Interrupt-driven channel activity detection method. DIO1 will be activated when LoRa preamble is detected, or upon timeout. More...
int16_t | getChannelScanResult () override
| Read the channel scan result. More...
int16_t | setBandwidth (float bw)
| Sets LoRa bandwidth. Allowed values are 62.5, 125.0, 250.0 and 500.0 kHz. More...
int16_t | setSpreadingFactor (uint8_t sf, bool legacy=false)
| Sets LoRa spreading factor. Allowed values range from 5 to 12. More...
int16_t | setCodingRate (uint8_t cr, bool longInterleave=false)
| Sets LoRa coding rate denominator. Allowed values range from 5 to 8. More...
int16_t | setSyncWord (uint8_t syncWord)
| Sets LoRa sync word. More...
int16_t | setBitRate (float br)
| Sets GFSK bit rate. Allowed values range from 0.6 to 300.0 kbps. More...
int16_t | setFrequencyDeviation (float freqDev) override
| Sets GFSK frequency deviation. Allowed values range from 0.0 to 200.0 kHz. More...
int16_t | setRxBandwidth (float rxBw)
| Sets GFSK receiver bandwidth. Allowed values are 4.8, 5.8, 7.3, 9.7, 11.7, 14.6, 19.5, 23.4, 29.3, 39.0, 46.9, 58.6, 78.2, 93.8, 117.3, 156.2, 187.2, 234.3, 312.0, 373.6 and 467.0 kHz. More...
int16_t | setSyncWord (uint8_t *syncWord, size_t len) override
| Sets GFSK sync word in the form of array of up to 8 bytes. More...
int16_t | setSyncBits (uint8_t *syncWord, uint8_t bitsLen)
| Sets GFSK sync word in the form of array of up to 8 bytes. More...
int16_t | setNodeAddress (uint8_t nodeAddr)
| Sets node address. Calling this method will also enable address filtering for node address only. More...
int16_t | setBroadcastAddress (uint8_t broadAddr)
| Sets broadcast address. Calling this method will also enable address filtering for node and broadcast address. More...
int16_t | disableAddressFiltering ()
| Disables address filtering. Calling this method will also erase previously set addresses. More...
int16_t | setDataShaping (uint8_t sh) override
| Sets time-bandwidth product of Gaussian filter applied for shaping. Allowed values are RADIOLIB_SHAPING_0_3, RADIOLIB_SHAPING_0_5, RADIOLIB_SHAPING_0_7 or RADIOLIB_SHAPING_1_0. Set to RADIOLIB_SHAPING_NONE to disable data shaping. More...
int16_t | setEncoding (uint8_t encoding) override
| Sets transmission encoding. Available in GFSK mode only. Serves only as alias for PhysicalLayer compatibility. More...
int16_t | fixedPacketLengthMode (uint8_t len=RADIOLIB_LR11X0_MAX_PACKET_LENGTH)
| Set modem in fixed packet length mode. Available in GFSK mode only. More...
int16_t | variablePacketLengthMode (uint8_t maxLen=RADIOLIB_LR11X0_MAX_PACKET_LENGTH)
| Set modem in variable packet length mode. Available in GFSK mode only. More...
int16_t | setWhitening (bool enabled, uint16_t initial=0x01FF)
| Sets GFSK whitening parameters. More...
int16_t | setDataRate (DataRate_t dr) override
| Set data. More...
int16_t | checkDataRate (DataRate_t dr) override
| Check the data rate can be configured by this module. More...
int16_t | setPreambleLength (size_t preambleLength) override
| Sets preamble length for LoRa or GFSK modem. Allowed values range from 1 to 65535. More...
int16_t | setTCXO (float voltage, uint32_t delay=5000)
| Sets TCXO (Temperature Compensated Crystal Oscillator) configuration. More...
int16_t | setCRC (uint8_t len, uint32_t initial=0x00001D0FUL, uint32_t polynomial=0x00001021UL, bool inverted=true)
| Sets CRC configuration. More...
int16_t | invertIQ (bool enable) override
| Enable/disable inversion of the I and Q signals. More...
float | getRSSI ()
| Gets RSSI (Recorded Signal Strength Indicator) of the last received packet. Only available for LoRa or GFSK modem. More...
float | getSNR ()
| Gets SNR (Signal to Noise Ratio) of the last received packet. Only available for LoRa modem. More...
float | getFrequencyError ()
| Gets frequency error of the latest received packet. More...
size_t | getPacketLength (bool update=true) override
| Query modem for the packet length of received payload. More...
size_t | getPacketLength (bool update, uint8_t *offset)
| Query modem for the packet length of received payload. More...
uint32_t | getTimeOnAir (size_t len) override
| Get expected time-on-air for a given size of payload. More...
float | getDataRate () const
| Gets effective data rate for the last transmitted packet. The value is calculated only for payload bytes. More...
int16_t | transmit (const char *str, uint8_t addr=0)
| C-string transmit method. More...
virtual int16_t | transmit (uint8_t *data, size_t len, uint8_t addr=0)
| Binary transmit method. Must be implemented in module class. More...
virtual int16_t | receive (uint8_t *data, size_t len)
| Binary receive method. Must be implemented in module class. More...
int16_t | startTransmit (const char *str, uint8_t addr=0)
| Interrupt-driven Arduino String transmit method. Unlike the standard transmit method, this one is non-blocking. Interrupt pin will be activated when transmission finishes. More...
virtual int16_t | startTransmit (uint8_t *data, size_t len, uint8_t addr=0)
| Interrupt-driven binary transmit method. More...
virtual int16_t | readData (uint8_t *data, size_t len)
| Reads data that was received after calling startReceive method. More...
Public Member Functions inherited from PhysicalLayer
| PhysicalLayer (float step, size_t maxLen)
| Default constructor. More...
int16_t | transmit (const char *str, uint8_t addr=0)
| C-string transmit method. More...
virtual int16_t | sleep ()
| Sets module to sleep. More...
virtual int16_t | standby (uint8_t mode)
| Sets module to a specific standby mode. More...
virtual int16_t | startReceive (uint32_t timeout, uint16_t irqFlags, uint16_t irqMask, size_t len)
| Interrupt-driven receive method. A DIO pin will be activated when full packet is received. Must be implemented in module class. More...
int16_t | startTransmit (const char *str, uint8_t addr=0)
| Interrupt-driven Arduino String transmit method. Unlike the standard transmit method, this one is non-blocking. Interrupt pin will be activated when transmission finishes. More...
float | getFreqStep () const
| Gets the module frequency step size that was set in constructor. More...
virtual uint32_t | calculateRxTimeout (uint32_t timeoutUs)
| Calculate the timeout value for this specific module / series (in number of symbols or units of time) More...
virtual int16_t | irqRxDoneRxTimeout (uint16_t &irqFlags, uint16_t &irqMask)
| Create the flags that make up RxDone and RxTimeout used for receiving downlinks. More...
virtual bool | isRxTimeout ()
| Check whether the IRQ bit for RxTimeout is set. More...
int32_t | random (int32_t max)
| Get truly random number in range 0 - max. More...
int32_t | random (int32_t min, int32_t max)
| Get truly random number in range min - max. More...
virtual uint8_t | randomByte ()
| Get one truly random byte from RSSI noise. Must be implemented in module class. More...
int16_t | startDirect ()
| Configure module parameters for direct modes. Must be called prior to "ham" modes like RTTY or AX.25. Only available in FSK mode. More...
int16_t | setDirectSyncWord (uint32_t syncWord, uint8_t len)
| Set sync word to be used to determine start of packet in direct reception mode. More...
virtual void | setDirectAction (void(*func)(void))
| Set interrupt service routine function to call when data bit is received in direct mode. Must be implemented in module class. More...
virtual void | readBit (uint32_t pin)
| Function to read and process data bit in direct reception mode. Must be implemented in module class. More...
int16_t | available ()
| Get the number of direct mode bytes currently available in buffer. More...
void | dropSync ()
| Forcefully drop synchronization.
uint8_t | read (bool drop=true)
| Get data from direct mode buffer. More...
virtual int16_t | setDIOMapping (uint32_t pin, uint32_t value)
| Configure DIO pin mapping to get a given signal on a DIO pin (if available). More...
virtual void | setChannelScanAction (void(*func)(void))
| Sets interrupt service routine to call when a channel scan is finished. More...
virtual void | clearChannelScanAction ()
| Clears interrupt service routine to call when a channel scan is finished.

## Additional Inherited Members
Public Attributes inherited from LR11x0
bool | XTAL
| Whether the module has an XTAL (true) or TCXO (false). Defaults to false.

## Detailed Description

Derived class for LR1110 modules.

## Constructor & Destructor Documentation

## ◆ LR1110()

LR1110::LR1110 | ( | Module * | mod | ) |

Default constructor.

Parameters

  mod | Instance of Module that will be used to communicate with the radio.

## Member Function Documentation

## ◆ begin()

int16_t LR1110::begin | ( | float | freq = `434.0`,
|  | float | bw = `125.0`,
|  | uint8_t | sf = `9`,
|  | uint8_t | cr = `7`,
|  | uint8_t | syncWord = `RADIOLIB_LR11X0_LORA_SYNC_WORD_PRIVATE`,
|  | int8_t | power = `10`,
|  | uint16_t | preambleLength = `8`,
|  | float | tcxoVoltage = `1.6`
| ) |  |

Initialization method for LoRa modem.

Parameters

  freq | Carrier frequency in MHz. Defaults to 434.0 MHz.
  bw | LoRa bandwidth in kHz. Defaults to 125.0 kHz.
  sf | LoRa spreading factor. Defaults to 9.
  cr | LoRa coding rate denominator. Defaults to 7 (coding rate 4/7).
  syncWord | 1-byte LoRa sync word. Defaults to RADIOLIB_LR11X0_LORA_SYNC_WORD_PRIVATE (0x12).
  power | Output power in dBm. Defaults to 10 dBm.
  preambleLength | LoRa preamble length in symbols. Defaults to 8 symbols.
  tcxoVoltage | TCXO reference voltage to be set. Defaults to 1.6 V. If you are seeing -706/-707 error codes, it likely means you are using non-0 value for module with XTAL. To use XTAL, either set this value to 0, or set LR11x0::XTAL to true.

Returns
  Status Codes

## ◆ beginGFSK()

int16_t LR1110::beginGFSK | ( | float | freq = `434.0`,
|  | float | br = `4.8`,
|  | float | freqDev = `5.0`,
|  | float | rxBw = `156.2`,
|  | int8_t | power = `10`,
|  | uint16_t | preambleLength = `16`,
|  | float | tcxoVoltage = `1.6`
| ) |  |

Initialization method for FSK modem.

Parameters

  freq | Carrier frequency in MHz. Defaults to 434.0 MHz.
  br | FSK bit rate in kbps. Defaults to 4.8 kbps.
  freqDev | Frequency deviation from carrier frequency in kHz. Defaults to 5.0 kHz.
  rxBw | Receiver bandwidth in kHz. Defaults to 156.2 kHz.
  power | Output power in dBm. Defaults to 10 dBm.
  preambleLength | FSK preamble length in bits. Defaults to 16 bits.
  tcxoVoltage | TCXO reference voltage to be set. Defaults to 1.6 V. If you are seeing -706/-707 error codes, it likely means you are using non-0 value for module with XTAL. To use XTAL, either set this value to 0, or set LR11x0::XTAL to true.

Returns
  Status Codes

## ◆ setFrequency() [1/2]

int16_t LR1110::setFrequency | ( | float | freq | ) |
| virtual

Sets carrier frequency. Allowed values are in range from 150.0 to 960.0 MHz. Will also perform calibrations.

Parameters

  freq | Carrier frequency to be set in MHz.

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ setFrequency() [2/2]

int16_t LR1110::setFrequency | ( | float | freq,
|  | bool | calibrate,
|  | float | band = `4`
| ) |  |

Sets carrier frequency. Allowed values are in range from 150.0 to 960.0 MHz.

Parameters

  freq | Carrier frequency to be set in MHz.
  calibrate | Run image calibration.
  band | Half bandwidth for image calibration. For example, if carrier is 434 MHz and band is set to 4 MHz, then the image will be calibrate for band 430 - 438 MHz. Unused if calibrate is set to false, defaults to 4 MHz

Returns
  Status Codes

## ◆ setOutputPower() [1/2]

int16_t LR1110::setOutputPower | ( | int8_t | power | ) |
| virtual

Sets output power. Allowed values are in range from -9 to 22 dBm (high-power PA) or -17 to 14 dBm (low-power PA).

Parameters

  power | Output power to be set in dBm, output PA is determined automatically preferring the low-power PA.

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ setOutputPower() [2/2]

int16_t LR1110::setOutputPower | ( | int8_t | power,
|  | bool | forceHighPower
| ) |  |

Sets output power. Allowed values are in range from -9 to 22 dBm (high-power PA) or -17 to 14 dBm (low-power PA).

Parameters

  power | Output power to be set in dBm.
  forceHighPower | Force using the high-power PA. If set to false, PA will be determined automatically based on configured output power, preferring the low-power PA. If set to true, only high-power PA will be used.

Returns
  Status Codes

The documentation for this class was generated from the following files:

- src/modules/LR11x0/LR1110.h
- src/modules/LR11x0/LR1110.cpp